/**=================================================================================================
Hochschule Luzern - Technik & Architektur                                   Mikrocontroller - HS2012
Copyright 2012 Felix Rohrer                                                     http://hslu.ximit.ch
----------------------------------------------------------------------------------------------------
Project     : Uebung_5-3
Name        : main.c
Author      : Felix Rohrer <felix.rohrer@stud.hslu.ch>
Version     : 2012-10-27v1.0
Description : Zeiger auf Funktion / Threads
              Implementieren Sie in der vorgegebenen Ampelsteuerung eine Callback-Funktion, damit
              die Zeiten der einzelnen Phasen ‚von aussen’ eingestellt werden können.
==================================================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include "semaphore.h"

/**
* Determins the length of each phase of the semaphor.
* @param phase actuel phase
* @return Time in ms for the corresponding phase
*/
int getPhaseTime(SemaphorStates_t phase)
{
	int rc = 1;
	switch (phase) {
        case GREEN:          rc = 6;  break;
        case GREEN_BLINKING: rc = 2;  break;
        case YELLOW:         rc = 2;  break;
        case RED:            rc = 10; break;
        default:             rc = 2;  break;
	}
	return rc;
}

/**
* Starts the semaphor and defines with the the implementation of a callback
* function the length of the various periods.
*/
int main(int argc, char** argv)
{
	//Set callback function 
	setSemaphorCallbackFunction(getPhaseTime);
	
	printf("Starting the semaphor...\n");
	startSemaphore();
    
	// Let the semaphor run for 1 minute
	sleep(60);
	printf("Stopping the semaphor...\n");
	stopSemaphor();
	printf("Semaphor stopped...\n");
    
	return (EXIT_SUCCESS);
}
